<html>
<head>
<title>OgreTechnique.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreTechnique.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreTechnique_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Technique_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Technique_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreBlendMode_8h.html">OgreBlendMode.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgrePass_8h.html">OgrePass.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderSystemCapabilities_8h.html">OgreRenderSystemCapabilities.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreUserObjectBindings_8h.html">OgreUserObjectBindings.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>Ogre {
<a name="l00053"></a><a class="code" href="classOgre_1_1Technique.html">00053</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">TechniqueAlloc</a>
<a name="l00054"></a>00054     {
<a name="l00055"></a>00055     <span class="keyword">protected</span>:
<a name="l00056"></a>00056         <span class="comment">// illumination pass state type</span>
<a name="l00057"></a><a class="code" href="classOgre_1_1Technique.html#a8dee9e7ef067309148721ed733264d23">00057</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Technique.html#a8dee9e7ef067309148721ed733264d23">IlluminationPassesState</a>
<a name="l00058"></a>00058         {
<a name="l00059"></a><a class="code" href="classOgre_1_1Technique.html#a8dee9e7ef067309148721ed733264d23a75b214ee6385d48d7ac8ffe63956ef9d">00059</a>             IPS_COMPILE_DISABLED = -1,
<a name="l00060"></a><a class="code" href="classOgre_1_1Technique.html#a8dee9e7ef067309148721ed733264d23a6d7b35400e16649614a7b7d2ff935c93">00060</a>             IPS_NOT_COMPILED = 0,
<a name="l00061"></a><a class="code" href="classOgre_1_1Technique.html#a8dee9e7ef067309148721ed733264d23abbba3e91e244942ff28459e90885ede7">00061</a>             IPS_COMPILED = 1
<a name="l00062"></a>00062         };
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classOgre_1_1Technique.html#a2578716e1f4b4cf2a9d3102a48aaf235">00064</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Pass*&gt;::type</a> <a class="code" href="classOgre_1_1Technique.html#a2578716e1f4b4cf2a9d3102a48aaf235">Passes</a>;
<a name="l00066"></a><a class="code" href="classOgre_1_1Technique.html#a45f4c97bd9168c67c4e7d5e68b2d0deb">00066</a>         <a class="code" href="classOgre_1_1Technique.html#a2578716e1f4b4cf2a9d3102a48aaf235">Passes</a> <a class="code" href="classOgre_1_1Technique.html#a45f4c97bd9168c67c4e7d5e68b2d0deb" title="List of primary passes.">mPasses</a>;
<a name="l00068"></a><a class="code" href="classOgre_1_1Technique.html#a6221e827be4159d329ae7909a542b10b">00068</a>         <a class="code" href="group__Materials.html#ga4c6928d029248ab4e1a4f999972baee8">IlluminationPassList</a> <a class="code" href="classOgre_1_1Technique.html#a6221e827be4159d329ae7909a542b10b" title="List of derived passes, categorised into IlluminationStage (ordered)">mIlluminationPasses</a>;
<a name="l00069"></a><a class="code" href="classOgre_1_1Technique.html#a19396048e38ac2ee8c49a1beeec22a1a">00069</a>         <a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>* <a class="code" href="classOgre_1_1Technique.html#a19396048e38ac2ee8c49a1beeec22a1a">mParent</a>; <span class="comment">// raw pointer since we don&#39;t want child to stop parent&#39;s destruction</span>
<a name="l00070"></a><a class="code" href="classOgre_1_1Technique.html#ab0140f0bcb0875742de251050440d546">00070</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Technique.html#ab0140f0bcb0875742de251050440d546">mIsSupported</a>;
<a name="l00071"></a><a class="code" href="classOgre_1_1Technique.html#a20375ceabd360a6b536a626da5033158">00071</a>         <a class="code" href="classOgre_1_1Technique.html#a8dee9e7ef067309148721ed733264d23">IlluminationPassesState</a> <a class="code" href="classOgre_1_1Technique.html#a20375ceabd360a6b536a626da5033158">mIlluminationPassesCompilationPhase</a>;
<a name="l00073"></a><a class="code" href="classOgre_1_1Technique.html#a640ffe897c7889af3e6c6c9d322afcf7">00073</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1Technique.html#a640ffe897c7889af3e6c6c9d322afcf7" title="LOD level.">mLodIndex</a>;
<a name="l00077"></a><a class="code" href="classOgre_1_1Technique.html#a0660deaa1aec81d2b440ab175d63514a">00077</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1Technique.html#a0660deaa1aec81d2b440ab175d63514a" title="Scheme index, derived from scheme name but the names are held on MaterialManager, for speed an index ...">mSchemeIndex</a>;
<a name="l00078"></a><a class="code" href="classOgre_1_1Technique.html#a386fbbee39283e296f9fb8bb3f4383f6">00078</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Technique.html#a386fbbee39283e296f9fb8bb3f4383f6">mName</a>; <span class="comment">// optional name for the technique</span>
<a name="l00079"></a>00079 
<a name="l00081"></a>00081         <span class="keywordtype">void</span> clearIlluminationPasses(<span class="keywordtype">void</span>);
<a name="l00083"></a>00083         <span class="keywordtype">bool</span> checkManuallyOrganisedIlluminationPasses();
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00090"></a><a class="code" href="classOgre_1_1Technique.html#a619d28fcc7d7763a6858f2e1a9499454">00090</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> <a class="code" href="classOgre_1_1Technique.html#a619d28fcc7d7763a6858f2e1a9499454" title="When casting shadow, if not using default Ogre shadow casting material, or nor using fixed function c...">mShadowCasterMaterial</a>;
<a name="l00095"></a><a class="code" href="classOgre_1_1Technique.html#a7abd113d2ad69679463a9928b546d2ac">00095</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Technique.html#a7abd113d2ad69679463a9928b546d2ac" title="When casting shadow, if not using default Ogre shadow casting material, or nor using fixed function c...">mShadowCasterMaterialName</a>;
<a name="l00100"></a><a class="code" href="classOgre_1_1Technique.html#a4d1b3ffc258b9a2430326d0bb903dbb1">00100</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> <a class="code" href="classOgre_1_1Technique.html#a4d1b3ffc258b9a2430326d0bb903dbb1" title="When receiving shadow, if not using default Ogre shadow receiving material, or nor using fixed functi...">mShadowReceiverMaterial</a>;
<a name="l00105"></a><a class="code" href="classOgre_1_1Technique.html#a6c4cb6c2977637223069c538986aa59e">00105</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Technique.html#a6c4cb6c2977637223069c538986aa59e" title="When receiving shadow, if not using default Ogre shadow receiving material, or nor using fixed functi...">mShadowReceiverMaterialName</a>; 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107         <span class="comment">// User objects binding.</span>
<a name="l00108"></a><a class="code" href="classOgre_1_1Technique.html#aed349028e71fba8fc7c8a5ea71c1066e">00108</a>         <a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a>  <a class="code" href="classOgre_1_1Technique.html#aed349028e71fba8fc7c8a5ea71c1066e">mUserObjectBindings</a>;
<a name="l00109"></a>00109 
<a name="l00110"></a>00110     <span class="keyword">public</span>:
<a name="l00114"></a><a class="code" href="classOgre_1_1Technique.html#a1ade219e17b5e8d73d079d11f64a2a2d">00114</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Technique.html#a1ade219e17b5e8d73d079d11f64a2a2d" title="Directive used to manually control technique support based on the inclusion or exclusion of some fact...">IncludeOrExclude</a>
<a name="l00115"></a>00115         {
<a name="l00117"></a><a class="code" href="classOgre_1_1Technique.html#a1ade219e17b5e8d73d079d11f64a2a2dabd4cc2de655eff5194cda7ea50d00ee3">00117</a>             INCLUDE = 0,
<a name="l00119"></a><a class="code" href="classOgre_1_1Technique.html#a1ade219e17b5e8d73d079d11f64a2a2da043f697946b7a6d01bb858768e6646a3">00119</a>             EXCLUDE = 1
<a name="l00120"></a>00120         };
<a name="l00122"></a><a class="code" href="structOgre_1_1Technique_1_1GPUVendorRule.html">00122</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1Technique_1_1GPUVendorRule.html" title="Rule controlling whether technique is deemed supported based on GPU vendor.">GPUVendorRule</a>
<a name="l00123"></a>00123         {
<a name="l00124"></a><a class="code" href="structOgre_1_1Technique_1_1GPUVendorRule.html#a79d34dde82e07466421e7fb2660d3db7">00124</a>             <a class="code" href="group__RenderSystem.html#gac4c251bcc05376f701348bfe0f4a53b4" title="Enumeration of GPU vendors.">GPUVendor</a> <a class="code" href="structOgre_1_1Technique_1_1GPUVendorRule.html#a79d34dde82e07466421e7fb2660d3db7">vendor</a>;
<a name="l00125"></a><a class="code" href="structOgre_1_1Technique_1_1GPUVendorRule.html#a60cb77ded55eb1fd08da385acf4ad903">00125</a>             <a class="code" href="classOgre_1_1Technique.html#a1ade219e17b5e8d73d079d11f64a2a2d" title="Directive used to manually control technique support based on the inclusion or exclusion of some fact...">IncludeOrExclude</a> <a class="code" href="structOgre_1_1Technique_1_1GPUVendorRule.html#a60cb77ded55eb1fd08da385acf4ad903">includeOrExclude</a>;
<a name="l00126"></a><a class="code" href="structOgre_1_1Technique_1_1GPUVendorRule.html#abe3caaaf5e149694cbd1b9b77ca3e6b1">00126</a>             <a class="code" href="structOgre_1_1Technique_1_1GPUVendorRule.html" title="Rule controlling whether technique is deemed supported based on GPU vendor.">GPUVendorRule</a>()
<a name="l00127"></a>00127                 : vendor(<a class="code" href="group__RenderSystem.html#ggac4c251bcc05376f701348bfe0f4a53b4a2d66ad2e2ce38c274d21f39551d2abe8">GPU_UNKNOWN</a>), includeOrExclude(EXCLUDE) {}
<a name="l00128"></a><a class="code" href="structOgre_1_1Technique_1_1GPUVendorRule.html#ac327a850fa93593d65c62b71f575b8bc">00128</a>             <a class="code" href="structOgre_1_1Technique_1_1GPUVendorRule.html" title="Rule controlling whether technique is deemed supported based on GPU vendor.">GPUVendorRule</a>(<a class="code" href="group__RenderSystem.html#gac4c251bcc05376f701348bfe0f4a53b4" title="Enumeration of GPU vendors.">GPUVendor</a> v, <a class="code" href="classOgre_1_1Technique.html#a1ade219e17b5e8d73d079d11f64a2a2d" title="Directive used to manually control technique support based on the inclusion or exclusion of some fact...">IncludeOrExclude</a> ie)
<a name="l00129"></a>00129                 : vendor(v), includeOrExclude(ie) {}
<a name="l00130"></a>00130         };
<a name="l00132"></a><a class="code" href="structOgre_1_1Technique_1_1GPUDeviceNameRule.html">00132</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1Technique_1_1GPUDeviceNameRule.html" title="Rule controlling whether technique is deemed supported based on GPU device name.">GPUDeviceNameRule</a>
<a name="l00133"></a>00133         {
<a name="l00134"></a><a class="code" href="structOgre_1_1Technique_1_1GPUDeviceNameRule.html#a3425c07d9ce84c5a7fa0c765b7dde8db">00134</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1Technique_1_1GPUDeviceNameRule.html#a3425c07d9ce84c5a7fa0c765b7dde8db">devicePattern</a>;
<a name="l00135"></a><a class="code" href="structOgre_1_1Technique_1_1GPUDeviceNameRule.html#afa5cd604584285e1d9dfe42734461673">00135</a>             <a class="code" href="classOgre_1_1Technique.html#a1ade219e17b5e8d73d079d11f64a2a2d" title="Directive used to manually control technique support based on the inclusion or exclusion of some fact...">IncludeOrExclude</a> <a class="code" href="structOgre_1_1Technique_1_1GPUDeviceNameRule.html#afa5cd604584285e1d9dfe42734461673">includeOrExclude</a>;
<a name="l00136"></a><a class="code" href="structOgre_1_1Technique_1_1GPUDeviceNameRule.html#a36e883f304b07d95ca55fea67f416d05">00136</a>             <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1Technique_1_1GPUDeviceNameRule.html#a36e883f304b07d95ca55fea67f416d05">caseSensitive</a>;
<a name="l00137"></a><a class="code" href="structOgre_1_1Technique_1_1GPUDeviceNameRule.html#ad912c591fde5ff1b38c2db11ae44d74c">00137</a>             <a class="code" href="structOgre_1_1Technique_1_1GPUDeviceNameRule.html" title="Rule controlling whether technique is deemed supported based on GPU device name.">GPUDeviceNameRule</a>()
<a name="l00138"></a>00138                 : includeOrExclude(EXCLUDE), caseSensitive(false) {}
<a name="l00139"></a><a class="code" href="structOgre_1_1Technique_1_1GPUDeviceNameRule.html#a5f70092f87cc455575f83813afb0ce53">00139</a>             <a class="code" href="structOgre_1_1Technique_1_1GPUDeviceNameRule.html" title="Rule controlling whether technique is deemed supported based on GPU device name.">GPUDeviceNameRule</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, <a class="code" href="classOgre_1_1Technique.html#a1ade219e17b5e8d73d079d11f64a2a2d" title="Directive used to manually control technique support based on the inclusion or exclusion of some fact...">IncludeOrExclude</a> ie, <span class="keywordtype">bool</span> caseSen)
<a name="l00140"></a>00140                 : devicePattern(pattern), includeOrExclude(ie), caseSensitive(caseSen) {}
<a name="l00141"></a>00141         };
<a name="l00142"></a><a class="code" href="classOgre_1_1Technique.html#aa110f5f6056965bfb02099099fb46958">00142</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;GPUVendorRule&gt;::type</a> <a class="code" href="classOgre_1_1Technique.html#aa110f5f6056965bfb02099099fb46958">GPUVendorRuleList</a>;
<a name="l00143"></a><a class="code" href="classOgre_1_1Technique.html#a98091dbc9cb06b40138458537c36e3ed">00143</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;GPUDeviceNameRule&gt;::type</a> <a class="code" href="classOgre_1_1Technique.html#a98091dbc9cb06b40138458537c36e3ed">GPUDeviceNameRuleList</a>;
<a name="l00144"></a>00144     <span class="keyword">protected</span>:
<a name="l00145"></a><a class="code" href="classOgre_1_1Technique.html#a874f049c7a6b21f3b91e12ca5860330e">00145</a>         <a class="code" href="classOgre_1_1Technique.html#aa110f5f6056965bfb02099099fb46958">GPUVendorRuleList</a> <a class="code" href="classOgre_1_1Technique.html#a874f049c7a6b21f3b91e12ca5860330e">mGPUVendorRules</a>;
<a name="l00146"></a><a class="code" href="classOgre_1_1Technique.html#a75739b100b635fbfd9760265239c34f3">00146</a>         <a class="code" href="classOgre_1_1Technique.html#a98091dbc9cb06b40138458537c36e3ed">GPUDeviceNameRuleList</a> <a class="code" href="classOgre_1_1Technique.html#a75739b100b635fbfd9760265239c34f3">mGPUDeviceNameRules</a>;
<a name="l00147"></a>00147     <span class="keyword">public</span>:
<a name="l00149"></a>00149         <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>(<a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>* parent);
<a name="l00151"></a>00151         <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>(<a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>* parent, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>&amp; oth);
<a name="l00152"></a>00152         ~<a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>();
<a name="l00158"></a>00158         <span class="keywordtype">bool</span> isSupported(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00162"></a>00162         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> _compile(<span class="keywordtype">bool</span> autoManageTextureUnits);
<a name="l00164"></a>00164         <span class="keywordtype">bool</span> checkGPURules(<a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; errors);
<a name="l00166"></a>00166         <span class="keywordtype">bool</span> checkHardwareSupport(<span class="keywordtype">bool</span> autoManageTextureUnits, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; compileErrors);
<a name="l00168"></a>00168         <span class="keywordtype">void</span> _compileIlluminationPasses(<span class="keywordtype">void</span>);
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00181"></a>00181         <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* createPass(<span class="keywordtype">void</span>);
<a name="l00183"></a>00183         <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* getPass(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00187"></a>00187         <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* getPass(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00189"></a>00189         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumPasses(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00191"></a>00191         <span class="keywordtype">void</span> removePass(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00193"></a>00193         <span class="keywordtype">void</span> removeAllPasses(<span class="keywordtype">void</span>);
<a name="l00197"></a>00197         <span class="keywordtype">bool</span> movePass(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> sourceIndex, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> destinationIndex);
<a name="l00198"></a><a class="code" href="classOgre_1_1Technique.html#a3b4640d3383f331657fd9ee05cb835c2">00198</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">VectorIterator&lt;Passes&gt;</a> <a class="code" href="classOgre_1_1Technique.html#a3b4640d3383f331657fd9ee05cb835c2">PassIterator</a>;
<a name="l00200"></a>00200         <span class="keyword">const</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">PassIterator</a> getPassIterator(<span class="keywordtype">void</span>);
<a name="l00201"></a><a class="code" href="classOgre_1_1Technique.html#a77a239a5901d2c67add2e7cea0bf3468">00201</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">VectorIterator&lt;IlluminationPassList&gt;</a> <a class="code" href="classOgre_1_1Technique.html#a77a239a5901d2c67add2e7cea0bf3468">IlluminationPassIterator</a>;
<a name="l00203"></a>00203         <span class="keyword">const</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">IlluminationPassIterator</a> getIlluminationPassIterator(<span class="keywordtype">void</span>);
<a name="l00205"></a><a class="code" href="classOgre_1_1Technique.html#a603fb40984083fbdfa1bf570cc602563">00205</a>         <a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>* <a class="code" href="classOgre_1_1Technique.html#a603fb40984083fbdfa1bf570cc602563" title="Gets the parent Material.">getParent</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mParent; }
<a name="l00206"></a>00206 
<a name="l00208"></a>00208         <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>&amp; rhs);
<a name="l00209"></a>00209 
<a name="l00211"></a>00211         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getResourceGroup(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00212"></a>00212 
<a name="l00221"></a>00221         <span class="keywordtype">bool</span> isTransparent(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00222"></a>00222 
<a name="l00228"></a>00228         <span class="keywordtype">bool</span> isTransparentSortingEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00229"></a>00229 
<a name="l00235"></a>00235         <span class="keywordtype">bool</span> isTransparentSortingForced(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00236"></a>00236 
<a name="l00238"></a>00238         <span class="keywordtype">void</span> _prepare(<span class="keywordtype">void</span>);
<a name="l00240"></a>00240         <span class="keywordtype">void</span> _unprepare(<span class="keywordtype">void</span>);
<a name="l00242"></a>00242         <span class="keywordtype">void</span> _load(<span class="keywordtype">void</span>);
<a name="l00244"></a>00244         <span class="keywordtype">void</span> _unload(<span class="keywordtype">void</span>);
<a name="l00245"></a>00245 
<a name="l00246"></a>00246         <span class="comment">// Is this loaded?</span>
<a name="l00247"></a>00247         <span class="keywordtype">bool</span> isLoaded(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00248"></a>00248 
<a name="l00250"></a>00250         <span class="keywordtype">void</span> _notifyNeedsRecompile(<span class="keywordtype">void</span>);
<a name="l00251"></a>00251 
<a name="l00254"></a>00254         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">Ogre::MaterialPtr</a> getShadowCasterMaterial() <span class="keyword">const</span>;
<a name="l00257"></a>00257         <span class="keywordtype">void</span> setShadowCasterMaterial(<a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">Ogre::MaterialPtr</a> val);
<a name="l00260"></a>00260         <span class="keywordtype">void</span> setShadowCasterMaterial(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;name);
<a name="l00263"></a>00263         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">Ogre::MaterialPtr</a> getShadowReceiverMaterial() <span class="keyword">const</span>;
<a name="l00266"></a>00266         <span class="keywordtype">void</span> setShadowReceiverMaterial(<a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">Ogre::MaterialPtr</a> val);
<a name="l00269"></a>00269         <span class="keywordtype">void</span> setShadowReceiverMaterial(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;name);
<a name="l00270"></a>00270 
<a name="l00271"></a>00271         <span class="comment">// -------------------------------------------------------------------------------</span>
<a name="l00272"></a>00272         <span class="comment">// The following methods are to make migration from previous versions simpler</span>
<a name="l00273"></a>00273         <span class="comment">// and to make code easier to write when dealing with simple materials</span>
<a name="l00274"></a>00274         <span class="comment">// They set the properties which have been moved to Pass for all Techniques and all Passes</span>
<a name="l00275"></a>00275 
<a name="l00284"></a>00284         <span class="keywordtype">void</span> setPointSize(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> ps);
<a name="l00285"></a>00285 
<a name="l00294"></a>00294         <span class="keywordtype">void</span> setAmbient(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> red, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> green, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> blue);
<a name="l00295"></a>00295 
<a name="l00304"></a>00304         <span class="keywordtype">void</span> setAmbient(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; ambient);
<a name="l00305"></a>00305 
<a name="l00314"></a>00314         <span class="keywordtype">void</span> setDiffuse(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> red, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> green, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> blue, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> alpha);
<a name="l00315"></a>00315 
<a name="l00324"></a>00324         <span class="keywordtype">void</span> setDiffuse(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; diffuse);
<a name="l00325"></a>00325 
<a name="l00334"></a>00334         <span class="keywordtype">void</span> setSpecular(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> red, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> green, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> blue, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> alpha);
<a name="l00335"></a>00335 
<a name="l00344"></a>00344         <span class="keywordtype">void</span> setSpecular(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; specular);
<a name="l00345"></a>00345 
<a name="l00354"></a>00354         <span class="keywordtype">void</span> setShininess(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> val);
<a name="l00355"></a>00355 
<a name="l00364"></a>00364         <span class="keywordtype">void</span> setSelfIllumination(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> red, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> green, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> blue);
<a name="l00365"></a>00365 
<a name="l00374"></a>00374         <span class="keywordtype">void</span> setSelfIllumination(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; selfIllum);
<a name="l00375"></a>00375 
<a name="l00384"></a>00384         <span class="keywordtype">void</span> setDepthCheckEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00385"></a>00385 
<a name="l00394"></a>00394         <span class="keywordtype">void</span> setDepthWriteEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00395"></a>00395 
<a name="l00404"></a>00404         <span class="keywordtype">void</span> setDepthFunction( <a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func );
<a name="l00405"></a>00405 
<a name="l00414"></a>00414         <span class="keywordtype">void</span> setColourWriteEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00415"></a>00415 
<a name="l00424"></a>00424         <span class="keywordtype">void</span> setCullingMode( <a class="code" href="group__General.html#gac173244ed7d950d0acd726e4f323ecdb" title="Hardware culling modes based on vertex winding.">CullingMode</a> mode );
<a name="l00425"></a>00425 
<a name="l00434"></a>00434         <span class="keywordtype">void</span> setManualCullingMode( <a class="code" href="group__General.html#ga07ec94cf178172a6778223e6f70f23fc" title="Manual culling modes based on vertex normals.">ManualCullingMode</a> mode );
<a name="l00435"></a>00435 
<a name="l00444"></a>00444         <span class="keywordtype">void</span> setLightingEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00445"></a>00445 
<a name="l00454"></a>00454         <span class="keywordtype">void</span> setShadingMode( <a class="code" href="group__General.html#ga7afd4c7d428baaee13f3a0dbcae5f560" title="Light shading modes.">ShadeOptions</a> mode );
<a name="l00455"></a>00455 
<a name="l00464"></a>00464         <span class="keywordtype">void</span> setFog(
<a name="l00465"></a>00465             <span class="keywordtype">bool</span> overrideScene,
<a name="l00466"></a>00466             <a class="code" href="group__General.html#ga83edeb2e5d33a3ca8f15834ba40020ba" title="Fog modes.">FogMode</a> mode = <a class="code" href="group__General.html#gga83edeb2e5d33a3ca8f15834ba40020baab7793a21880052c0214d4cc040992310" title="No fog. Duh.">FOG_NONE</a>,
<a name="l00467"></a>00467             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour = <a class="code" href="classOgre_1_1ColourValue.html#a8eba66b2908f44f00f8d9c9ec25877de">ColourValue::White</a>,
<a name="l00468"></a>00468             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> expDensity = 0.001, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linearStart = 0.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linearEnd = 1.0 );
<a name="l00469"></a>00469 
<a name="l00478"></a>00478         <span class="keywordtype">void</span> setDepthBias(<span class="keywordtype">float</span> constantBias, <span class="keywordtype">float</span> slopeScaleBias);
<a name="l00479"></a>00479 
<a name="l00488"></a>00488         <span class="keywordtype">void</span> setTextureFiltering(<a class="code" href="group__General.html#ga21a0186392e9c9ce16d29c5568a773c5" title="High-level filtering options providing shortcuts to settings the minification, magnification and mip ...">TextureFilterOptions</a> filterType);
<a name="l00497"></a>00497         <span class="keywordtype">void</span> setTextureAnisotropy(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxAniso);
<a name="l00498"></a>00498 
<a name="l00507"></a>00507         <span class="keywordtype">void</span> setSceneBlending( <span class="keyword">const</span> <a class="code" href="group__Materials.html#gac46c60cf6e5c199220e3b8f26570cb9a" title="Types of blending that you can specify between an object and the existing contents of the scene...">SceneBlendType</a> sbt );
<a name="l00508"></a>00508 
<a name="l00517"></a>00517         <span class="keywordtype">void</span> setSeparateSceneBlending( <span class="keyword">const</span> <a class="code" href="group__Materials.html#gac46c60cf6e5c199220e3b8f26570cb9a" title="Types of blending that you can specify between an object and the existing contents of the scene...">SceneBlendType</a> sbt, <span class="keyword">const</span> <a class="code" href="group__Materials.html#gac46c60cf6e5c199220e3b8f26570cb9a" title="Types of blending that you can specify between an object and the existing contents of the scene...">SceneBlendType</a> sbta );
<a name="l00518"></a>00518 
<a name="l00527"></a>00527         <span class="keywordtype">void</span> setSceneBlending( <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactor, <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactor);
<a name="l00528"></a>00528 
<a name="l00537"></a>00537         <span class="keywordtype">void</span> setSeparateSceneBlending( <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactor, <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactor, <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactorAlpha, <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactorAlpha);
<a name="l00538"></a>00538 
<a name="l00555"></a>00555         <span class="keywordtype">void</span> setLodIndex(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00557"></a><a class="code" href="classOgre_1_1Technique.html#af70e2e5fec4b833152ec435b4d105be7">00557</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1Technique.html#af70e2e5fec4b833152ec435b4d105be7" title="Gets the level-of-detail index assigned to this Technique.">getLodIndex</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLodIndex; }
<a name="l00558"></a>00558 
<a name="l00576"></a>00576         <span class="keywordtype">void</span> setSchemeName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; schemeName);
<a name="l00580"></a>00580         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getSchemeName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00581"></a>00581         
<a name="l00583"></a>00583         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> _getSchemeIndex(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00584"></a>00584             
<a name="l00586"></a>00586         <span class="keywordtype">bool</span> isDepthWriteEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00587"></a>00587 
<a name="l00589"></a>00589         <span class="keywordtype">bool</span> isDepthCheckEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00590"></a>00590 
<a name="l00592"></a>00592         <span class="keywordtype">bool</span> hasColourWriteDisabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00593"></a>00593 
<a name="l00599"></a>00599         <span class="keywordtype">void</span> setName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00601"></a><a class="code" href="classOgre_1_1Technique.html#af577087e6a66bd0a29a58d042b3a6d16">00601</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1Technique.html#af577087e6a66bd0a29a58d042b3a6d16" title="Gets the name of the technique.">getName</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00602"></a>00602 
<a name="l00614"></a>00614         <span class="keywordtype">bool</span> applyTextureAliases(<span class="keyword">const</span> <a class="code" href="group__General.html#ga20898062bd79359acd1137276d9b0e37" title="Alias / Texture name pair (first = alias, second = texture name)">AliasTextureNamePairList</a>&amp; aliasList, <span class="keyword">const</span> <span class="keywordtype">bool</span> apply = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 
<a name="l00632"></a>00632         <span class="keywordtype">void</span> addGPUVendorRule(<a class="code" href="group__RenderSystem.html#gac4c251bcc05376f701348bfe0f4a53b4" title="Enumeration of GPU vendors.">GPUVendor</a> vendor, IncludeOrExclude includeOrExclude);
<a name="l00646"></a>00646         <span class="keywordtype">void</span> addGPUVendorRule(<span class="keyword">const</span> GPUVendorRule&amp; rule);
<a name="l00650"></a>00650         <span class="keywordtype">void</span> removeGPUVendorRule(<a class="code" href="group__RenderSystem.html#gac4c251bcc05376f701348bfe0f4a53b4" title="Enumeration of GPU vendors.">GPUVendor</a> vendor);
<a name="l00651"></a><a class="code" href="classOgre_1_1Technique.html#a2497a0043902e9d2af0757d769da655c">00651</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstVectorIterator&lt;GPUVendorRuleList&gt;</a> <a class="code" href="classOgre_1_1Technique.html#a2497a0043902e9d2af0757d769da655c">GPUVendorRuleIterator</a>;
<a name="l00653"></a>00653         <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">GPUVendorRuleIterator</a> getGPUVendorRuleIterator() <span class="keyword">const</span>;
<a name="l00654"></a>00654 
<a name="l00672"></a>00672         <span class="keywordtype">void</span> addGPUDeviceNameRule(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; devicePattern, <a class="code" href="classOgre_1_1Technique.html#a1ade219e17b5e8d73d079d11f64a2a2d" title="Directive used to manually control technique support based on the inclusion or exclusion of some fact...">IncludeOrExclude</a> includeOrExclude, <span class="keywordtype">bool</span> caseSensitive = <span class="keyword">false</span>);
<a name="l00687"></a>00687         <span class="keywordtype">void</span> addGPUDeviceNameRule(<span class="keyword">const</span> <a class="code" href="structOgre_1_1Technique_1_1GPUDeviceNameRule.html" title="Rule controlling whether technique is deemed supported based on GPU device name.">GPUDeviceNameRule</a>&amp; rule);
<a name="l00691"></a>00691         <span class="keywordtype">void</span> removeGPUDeviceNameRule(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; devicePattern);
<a name="l00692"></a><a class="code" href="classOgre_1_1Technique.html#a63da4eb10f7272486a9806374b09bab6">00692</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstVectorIterator&lt;GPUDeviceNameRuleList&gt;</a> <a class="code" href="classOgre_1_1Technique.html#a63da4eb10f7272486a9806374b09bab6">GPUDeviceNameRuleIterator</a>;
<a name="l00694"></a>00694         <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">GPUDeviceNameRuleIterator</a> getGPUDeviceNameRuleIterator() <span class="keyword">const</span>;
<a name="l00695"></a>00695 
<a name="l00700"></a><a class="code" href="classOgre_1_1Technique.html#a96db53bdf6b3f097fcb9a038df84abe9">00700</a>         <a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a>&amp; <a class="code" href="classOgre_1_1Technique.html#a96db53bdf6b3f097fcb9a038df84abe9" title="Return an instance of user objects binding associated with this class.">getUserObjectBindings</a>() { <span class="keywordflow">return</span> mUserObjectBindings; }
<a name="l00701"></a>00701 
<a name="l00706"></a><a class="code" href="classOgre_1_1Technique.html#aded444b9a20ee36d9a8a7a457d9b3e69">00706</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a>&amp; <a class="code" href="classOgre_1_1Technique.html#aded444b9a20ee36d9a8a7a457d9b3e69" title="Return an instance of user objects binding associated with this class.">getUserObjectBindings</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUserObjectBindings; }
<a name="l00707"></a>00707 
<a name="l00708"></a>00708     };
<a name="l00709"></a>00709 
<a name="l00713"></a>00713 }
<a name="l00714"></a>00714 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
